//DEVILS
//Winter 2008 Contest
//Copyright by Tino Vogel


#define GAME_SIZE_X  				pan_playground_p1.size_x
#define GAME_SIZE_Y  				pan_playground_p1.size_y
#define GAME_AREA    				GAME_SIZE_X * GAME_SIZE_Y
#define DRAW_OFFSET  				vector(-integer(PLAYER_SIZE/2), -integer(PLAYER_SIZE/2), 0)
#define vec_vset(vec, a, b, c)	vec_set(vec, vector(a, b, c))
#define new(func) 					ent_create(NULL, nullvector, func)

#define PLAYER_SIZE  5		//Pixelgre der Figuren
#define TARGET			80		//Prozentwert fr Levelaufstieg
#define TIME_BONUS	30		//Zeitbonus bei Levelaufstieg
#define TIME_START	90		//Zeit bei Spielbeginn (Sekunden)	

#define SAFE			0
#define UP				1
#define DOWN 			2
#define LEFT			3
#define RIGHT			4

#define prev_section shadow

//#define 
#define PLAYER1		1
#define PLAYER2		2
#define DEVIL			3
#define V_LINE			4
#define H_LINE			5
#define RECTANGLE		6

#define line_start_x		skill1
#define section_start_x	skill4
#define dir_x				skill7 
#define dir_y           skill8	//7, 8 --> DEVIL, 9 --> PLAYER
#define dir					skill9
#define color				skill10
#define lives				skill13
#define percent			skill14
#define id					skill15 
#define typ					skill16
#define prev_pos        skill17
#define prev_dir        skill20
#define draw_pos			skill23
#define draw_size_x		skill26
#define draw_size_y		skill27
#define area				skill29
#define SECTION_SUCCESS	FLAG3
#define SECTION_READY	FLAG4
#define SAFE_AREA			FLAG5
#define LINE_RESET		FLAG6
#define LINE_ERROR      FLAG7
#define LINE_SUCCESS    FLAG8

typedef struct LANGUAGES
{
	STRING* language;
	STRING* intro;
	STRING* p2_enabled;
	STRING* p2_disabled;
	STRING* p1_won;
	STRING* p2_won;
	STRING* str_level;
	STRING* str_lives;
	STRING* str_percent;
} LANGUAGES;

LANGUAGES languages[2];

void init_strings()
{
	languages[0].language = "English";
	languages[0].intro = "DEVILS\n\nWelcome!\n\n\nTake minimum 80 percent of the surface of the Devils.\n\nHandling\n\n
								In game\nCursorkeys - Move player (Player2: WASD)\nEsc - Menu\nP - Pause\n\n
								In menu\nL - Change language\nSpace - toggle second Player\nEnter - Start game\nEsc - Exit\n\n\n";
	languages[0].p2_enabled = "Player 2 is activated.";
	languages[0].p2_disabled = "Player 2 is deactivated.";
	languages[0].p1_won = "Player 1 won.";
	languages[0].p2_won = "Player 2 won.";
	languages[0].str_level = "Level: ";
	languages[0].str_lives = "Lives: ";
	languages[0].str_percent = "Percent: ";
	
	languages[1].language = "Deutsch";
	languages[1].intro = "DEVILS\n\nWillkommen!\n\n\nNehme den DEVILS mindestens 80% ihrer Flche.\n\nTastenbelegung\n\n
								Im Spiel\nCursortasten - Spieler bewegen (Spieler2: WASD)\nEsc - Hauptmen\nP - Pause\n\n
								Im Men\nL - Sprache wechseln\nLeertaste - Spielmodus ndern\nEnter - Spiel starten\nEsc - Beenden\n\n\n";
	languages[1].p2_enabled = "Spieler 2 ist aktiviert.";
	languages[1].p2_disabled = "Spieler 2 ist deaktiviert.";
	languages[1].p1_won = "Spieler 1 hat gewonnen.";
	languages[1].p2_won = "Spieler 2 hat gewonnen.";
	languages[1].str_level = "Level: ";
	languages[1].str_lives = "Leben: ";
	languages[1].str_percent = "Prozent: ";
}

#define ENABLE_PLAYER2 (1<<0) //is set when second player is activated
#define INGAME         (1<<1) //is set when game is active
#define GERMAN			  (1<<2) //is set when language is set to german
#define PAUSE			  (1<<3) //is set when game is paused

#define bool_set(BOOL)    boolean |=  (BOOL)
#define bool_reset(BOOL)  boolean &= ~(BOOL)
#define bool_toggle(BOOL) boolean ^=  (BOOL)
#define bool_get(BOOL)    result = boolean & (BOOL)

var boolean = 0;

var mouse_move_up[2] = {72, 17};
var mouse_move_down[2] = {80, 31};
var mouse_move_left[2] = {75, 30};
var mouse_move_right[2] = {77, 32};

var time;
var anz_devils = 2;

var* p1_lives;
var* p2_lives;
var* p1_percent;
var* p2_percent;

STRING* str_intro = "";
STRING* str_ingame = "";

FONT* arial_font = "Arial#15"; 

PANEL* pan_playground_p1 =
{
	layer = 0;
	size_x = 800;
	size_y = 600;
	blue = 255; green = 255; red = 255;
	digits(100, -30, 1, arial_font, 1, p1_lives);
	digits(200, -30, 2, arial_font, 1, p1_percent);
	flags = VISIBLE | LIGHT;
}

PANEL* pan_playground_p2 =
{
	layer = 0;
	size_x = 390;
	size_y = 600;
	blue = 255; green = 255; red = 255;
	digits(100, -30, 1, arial_font, 1, p2_lives);
	digits(200, -30, 2, arial_font, 1, p2_percent);
	flags = VISIBLE | LIGHT;
}

TEXT* txt_intro =
{
	layer=1;
	font = arial_font;
	red = 64;
	green = 64;
	blue = 64;
	string = str_intro;
	flags = CENTER_X;
}

TEXT* txt_ingame =
{
	layer=1;
	pos_x = 512;
	pos_y = 50;
	font = arial_font;
	red = 255;
	green = 255;
	blue = 255;
	string = str_ingame;
	flags = CENTER_X;
}

void show_menu();
void show_intro();
void devil_move (PANEL* parent);
void player_move (PANEL* parent);
void hero();
void devil();
void line();
void create_devils(var num);
void create_players();
void draw_entity();

int main()
{
	mouse_mode=2;
	video_aspect=4/3;
	video_switch(8,32,1);
	video_window(NULL, NULL,256,"DEVILS");
	vec_fill(sky_color, 1);
	
	init_strings();
	
	level_load(NULL);
	
	pan_playground_p1.pos_x = screen_size.x/2 - GAME_SIZE_X/2;
	pan_playground_p2.pos_x = screen_size.x/2 + 10;
	pan_playground_p1.pos_y = pan_playground_p2.pos_y = screen_size.y/2 - GAME_SIZE_Y/2;
	txt_intro.pos_x = screen_size.x/2;
	txt_intro.pos_y = pan_playground_p1.pos_y + 100;
	
	randomize();
	
	bool_set(INGAME);
	show_menu();
}

void ent_remove_all()
{
	you = ent_next(NULL);
	while(you)
	{
		set(you, INVISIBLE);
		you = ent_next(you);
	}
	wait(1);
}

void show_menu()
{
	bool_get(INGAME);
	if (result)
	{	
		anz_devils = 2;
		ent_remove_all();
		pan_playground_p1.size_x = 800;
		reset(pan_playground_p2, VISIBLE);
		bool_reset(INGAME | PAUSE);
	   create_devils(30);
		show_intro();
	}
	else
		sys_exit("");
}

void show_intro()
{  
	bool_get(GERMAN);
	if (!result)
	{
		str_cpy(str_intro, languages[0].intro);
		bool_get(ENABLE_PLAYER2);
		if (result)
			str_cat(str_intro, languages[0].p2_enabled);
		else
			str_cat(str_intro, languages[0].p2_disabled);
	}
	else
	{
		str_cpy(str_intro, languages[1].intro);
		bool_get(ENABLE_PLAYER2);
		if (result)
			str_cat(str_intro, languages[1].p2_enabled);
		else
			str_cat(str_intro, languages[1].p2_disabled);
	}
	set(txt_intro, VISIBLE);
}

void show_ingame()
{
	STRING* temp = "";
	str_cpy(str_ingame, languages[0].str_level);
	str_for_num(temp, anz_devils - 1);
	str_cat(str_ingame, temp);
	set(txt_ingame, VISIBLE);
}

void start_game()
{
	bool_get(INGAME);
	if (!result)
	{
		ent_remove_all();
		reset(txt_intro, VISIBLE);
		bool_get(ENABLE_PLAYER2);
		if (result)
		{
			pan_playground_p1.size_x = 390;
			set(pan_playground_p2, VISIBLE);
		}
		bool_set(INGAME);
		create_devils(anz_devils);
		create_players();
		show_ingame();
	}
}

void create_devils(var num)
{
	var i;
	for (i=0; i < num; i++)
	{
		you = new(devil);
		you.id = 100+i;
	}
	
	bool_get(INGAME);
	if (result)
	{
		bool_get(ENABLE_PLAYER2);
		if (result)
		{
			for (i=0; i < num; i++)
			{
				you = new(devil);
				you.id = 200+i;
			}
		}
	}
}

void devil()
{
	PANEL* pan_parent;
	
	my.typ = DEVIL;
	wait(1);
	
	if (my.id<200)
		pan_parent = pan_playground_p1;
	else
		pan_parent = pan_playground_p2;
	
	my.min_x = pan_parent.pos_x + integer(PLAYER_SIZE/2);
	my.max_x = pan_parent.pos_x + GAME_SIZE_X - integer(PLAYER_SIZE/2);
	my.min_y = pan_parent.pos_y + integer(PLAYER_SIZE/2);
	my.max_y = pan_parent.pos_y + GAME_SIZE_Y - integer(PLAYER_SIZE/2);

	my.x = random(my.max_x - my.min_x) + my.min_x;
	my.y = random(my.max_y - my.min_y) + my.min_y;
	
	vec_vset(my.blue, 0, 0, 255);
	vec_vset(my.dir_x, integer(random(2)) * 2 - 1, integer(random(2)) * 2 - 1, 0);
	vec_scale(my.dir_x, 5);
	
	do
	{
		bool_get(PAUSE);
		if (!result)
			devil_move(pan_parent);
		draw_entity();
		wait(1);
	}while(!is(me,INVISIBLE));
	ent_remove(me);	
}

void devil_move (PANEL* parent)
{
	vec_add(my.x, my.dir_x);
	
	my.x = clamp(my.x, my.min_x, my.max_x);
	my.y = clamp(my.y, my.min_y, my.max_y);
	
	if ((my.x == my.min_x) || (my.x == my.max_x))
		my.dir_x *= -1;
	if ((my.y == my.min_y) || (my.y == my.max_y))
		my.dir_y *= -1;
}

void create_players()
{
	you = new(hero);
	you.id = 0;
	
	bool_get(ENABLE_PLAYER2);
	if (result)
	{
		you = new(hero);
		you.id = 1;
	}
}

void next_level()
{
	
	/*bool_get(ENABLE_PLAYER2);
	if (result)
	{
		
	}*/
	
	anz_devils++;
	bool_reset(INGAME);
	start_game();
}

//bergabe:
//	min: obere linke Ecke des Bereichs
// max: untere rechte Ecke des Bereichs
// art: Entity-Typ, nach dem geprft werden soll
// ent: Start-Entity oder NULL, wenn von Anfang an gesucht werden soll
ENTITY* check_area (VECTOR* min, VECTOR* max, var art, ENTITY* ent)
{
	ent = ent_next(ent);
	while(ent)
	{
		if ((ent.typ == art)
		&&  (ent.x >= min.x) && (ent.x <= max.x)
		&&  (ent.y >= min.y) && (ent.y <= max.y))
		{
			return (ent);
		}
		ent = ent_next(ent);
	}
	return (NULL);
}

void set_percent(ENTITY* rect, var faktor)
{
	vec_diff(rect.draw_size_x, rect.max_x, rect.min_x);
	my.parent.area += rect.draw_size_x * rect.draw_size_y * faktor;
	my.parent.percent = (my.parent.area/5) / (GAME_AREA/5) * 100;
}

void rectangle()
{
	wait(1);
	my.typ = RECTANGLE;
	set_percent(me, 1);
	if (my.parent.percent > TARGET)
	{
		next_level();
		ent_remove(me);
		return;
	}
	
	set(me, SAFE_AREA);
	
	you = ent_next(NULL);
	while(you)
	{
		if ((you!=me)
		&&	((you.typ == V_LINE) || (you.typ == H_LINE) || (you.typ == RECTANGLE))
		&&  (you.min_x >= my.min_x) && (you.max_x <= my.max_x)
		&&  (you.min_y >= my.min_y) && (you.max_y <= my.max_y))
		{
			if (you.typ == RECTANGLE)
				set_percent(you, -1);
				
			set(you, INVISIBLE);
		}
		you = ent_next(you);
	}
	
	
	do
	{
		draw_quad(NULL, my.min_x, NULL, my.draw_size_x, nullvector, my.parent.color, 100,0);
		wait(1);
	}while(!is(me,INVISIBLE));
	ent_remove(me);
}

/*Annahmen/Bedingungen:
Eine Linie teilt den durchquerten Bereich immer in zwei Teile (Teil A und B)!
Teil A befindet sich immer zur rechten bzw. oberenen Seite des Eintrittspunktes der Linie!
Ein Teil kann aus mehreren Subteilen bestehen, je nach Anzahl der Sektionen!
Sobald fr ein Subteil festgestellt wurde, dass ein Teufel sich drin befindet, ist das gesamte Teil futsch!
Wenn das Teil A erfolgreich war, knnen die Devils nur in Teil B sein -> muss nicht geprft werden!
*/
void evaluate(PANEL* pan_parent)
{
	ENTITY* ent_origin;
	ENTITY* ent_current1;
	ENTITY* ent_current2;
	var min[3];
	var max[3];
	var anz_segments = 0;
	var i;
	var seite;
	
	ent_origin = my.parent;
	ent_current1 = my.parent;
	
	do
	{
		anz_segments++;
		ent_current1 = ent_current1.prev_section;
	}while (ent_current1);
	
	
	
	for (seite=0; seite<1; seite++)
	{
		ent_current2 = ent_origin;
		
		for (i=0; i<anz_segments-1; i+=2)
		{
			ent_current1 = ent_current2;
			ent_current2 = ent_current1.prev_section;
			
			//Ecken des Rechtecks bestimmen
			vec_set(min, vector(minv(minv(ent_current1.x, ent_current2.x), maxv(ent_current1.draw_size_x, ent_current2.draw_size_x)),
									  minv(minv(ent_current1.y, ent_current2.y), maxv(ent_current1.draw_size_y, ent_current2.draw_size_y)), 0));
			vec_set(max, vector(maxv(maxv(ent_current1.x, ent_current2.x), maxv(ent_current1.draw_size_x, ent_current2.draw_size_x)),
									  maxv(maxv(ent_current1.y, ent_current2.y), maxv(ent_current1.draw_size_y, ent_current2.draw_size_y)), 0));
			
			//Bereich auf DEVILS prfen
			you = check_area(min, max, DEVIL, NULL);
			
			if (!you)		
			{
				you = new(rectangle);
				vec_set(you.min_x, min);
				vec_set(you.max_x, max);
				you.parent = me;
			}
		}
	}
	
	/*if(anz_segments % 2)  //ungerade Anzahl Segmente? (Linie von einer Seite zur gegenberliegenden)
	{
		
	}
	else //gerade Anzahl Segmente? (Linie von einer Seite zu einer anliegenden --> 90)
	{
		
	}*/
	/*
	for (i=0; i<anz_segments-1; i++)
	{
		ent_current1 = ent_current2;
		ent_current2 = ent_current1.prev_section;
		
		//Ecken des Rechtecks bestimmen
		vec_set(min, vector(minv(minv(ent_current1.x, ent_current2.x), maxv(ent_current1.draw_size_x, ent_current2.draw_size_x)),
								  minv(minv(ent_current1.y, ent_current2.y), maxv(ent_current1.draw_size_y, ent_current2.draw_size_y)), 0));
		vec_set(max, vector(maxv(maxv(ent_current1.x, ent_current2.x), maxv(ent_current1.draw_size_x, ent_current2.draw_size_x)),
								  maxv(maxv(ent_current1.y, ent_current2.y), maxv(ent_current1.draw_size_y, ent_current2.draw_size_y)), 0));
		
		//Bereich auf DEVILS prfen
		you = check_area(min, max, DEVIL, NULL);
		
		if (!you)		
		{
			you = new(rectangle);
			vec_set(you.min_x, min);
			vec_set(you.max_x, max);
			you.parent = me;
		}
	}*/
}

//setzt allen Abschnitten der aktuellen Linie die bergebenen Flags
void set_sections(var flags)
{
	do
	{
		set(my.parent, flags);
		my.parent = my.parent.prev_section;
	}while (my.parent);
	my.prev_section = NULL;
}

void hero()
{
	PANEL* pan_parent;
	
	my.lives = 3;
	my.percent = 0;
	my.area = 0;
	wait(1);
	
	if (!my.id)
	{
		pan_parent = pan_playground_p1;
		p1_lives = &my.lives;
		p1_percent = &my.percent;
		my.typ = PLAYER1;
	}
	else
	{
		pan_parent = pan_playground_p2;
		p2_lives = &my.lives;
		p2_percent = &my.percent;
		my.typ = PLAYER2;
	}
	
	my.min_x = pan_parent.pos_x - PLAYER_SIZE + integer(PLAYER_SIZE/2);
	my.max_x = pan_parent.pos_x + GAME_SIZE_X + integer(PLAYER_SIZE/2);
	my.min_y = pan_parent.pos_y - PLAYER_SIZE + integer(PLAYER_SIZE/2);
	my.max_y = pan_parent.pos_y + GAME_SIZE_Y + integer(PLAYER_SIZE/2);
	
	my.x = pan_parent.pos_x + GAME_SIZE_X/2;
	my.y = my.min_y;
	
	vec_fill(my.blue, 128);
	vec_set(my.color, vector(random(255),random(255),random(255)));
	my.dir = SAFE;
	
	do
	{
		if(is(me, LINE_ERROR))
		{
			set_sections(INVISIBLE);
			vec_set(my.x, my.line_start_x);
			my.dir = SAFE;
			my.prev_dir = SAFE;
			my.lives--;
			reset(me, LINE_ERROR);
			if (!my.lives)
			{
				show_menu();
				ent_remove(me);
				return;
			}
		}	
		bool_get(PAUSE);
		if (!result)
			player_move(pan_parent);
		draw_entity();
		wait(1);
	}while(!is(me,INVISIBLE));
	ent_remove(me);
}

void draw_entity()
{
	vec_set(my.draw_pos, my.x);
	vec_add(my.draw_pos, DRAW_OFFSET);	
	draw_quad(NULL, my.draw_pos, NULL, vector(PLAYER_SIZE, PLAYER_SIZE, 0), nullvector, my.blue, 100,0);
}

void check_entities()
{
	ENTITY* temp;
	
	temp = check_area(my.min_x, my.max_x, DEVIL, NULL);
	while (temp)
	{
		if (!is(me, SAFE_AREA)) //Linie noch nicht fertig
		{
			set(my.parent, LINE_ERROR);
			return;
		}
		if (my.typ == V_LINE)
			temp.dir_x *= -1;
		else
			temp.dir_y *= -1;	
		temp = check_area(my.min_x, my.max_x, DEVIL, temp);
	}
}

void vec_clamp(VECTOR* vec, VECTOR* min, VECTOR* max)
{
	vec.x = clamp(vec.x, min.x, max.x);
	vec.y = clamp(vec.y, min.y, max.y);
	vec.z = clamp(vec.z, min.z, max.z);
}

void player_move (PANEL* parent)
{
	vec_set(my.prev_pos, my.x);
	my.prev_dir = my.dir;

	if (key_pressed(mouse_move_right[my.id]))
	{
		my.x += 5;
		my.dir = RIGHT;
	}
	else if (key_pressed(mouse_move_left[my.id]))
	{
		my.x -= 5;
		my.dir = LEFT;
	}
	else if (key_pressed(mouse_move_down[my.id]))
	{
		my.y += 5;
		my.dir = DOWN;
	}
	else if (key_pressed(mouse_move_up[my.id]))
	{
		my.y -= 5;
		my.dir = UP;
	}
	else 
	{	
		return;
	}
	
	vec_clamp(my.x, my.min_x, my.max_x);

	if (!check_area (parent.pos_x, vector(parent.pos_x + GAME_SIZE_X, parent.pos_y + GAME_SIZE_Y, 0), my.typ, NULL)) //nicht auf dem Spielfeld?
	{
		my.dir = SAFE;
	}
	else
	{
		you = ent_next(NULL);
		while((you) && (my.dir != SAFE))
		{
			if ((you!=my.parent)
			&& ((you.typ == RECTANGLE)||(you.typ == V_LINE)||(you.typ == H_LINE))
			&&  (check_area (you.min_x, you.max_x, my.typ, NULL)))
			{
				my.dir = SAFE;
			}
			you = ent_next(you);
		}
	}
	
	switch (my.dir)
	{
		case SAFE:	//sicherer Bereich?
			if (my.prev_dir != SAFE) //wenn vorher noch auf Spielflche... (erfolgreicher Linienabschluss)
			{
				if ((my.prev_dir == UP) || (my.prev_dir == LEFT))
				{
					vec_set(my.parent.x, my.x);
					vec_clamp(my.parent.x, parent.pos_x,vector(parent.pos_x + GAME_SIZE_X, parent.pos_y + GAME_SIZE_Y, 0));
				}
				else
				{
					vec_set(my.parent.draw_size_x, my.x);
					vec_clamp(my.parent.draw_size_x, parent.pos_x,vector(parent.pos_x + GAME_SIZE_X, parent.pos_y + GAME_SIZE_Y, 0));
				}
				evaluate(parent);
				set_sections(SECTION_READY | SAFE_AREA);
			}
			break;
				
		case UP:		//Zug nach oben?
			if(my.prev_dir != UP)	//neu in diese Richtung gekommen?
			{
				if (my.prev_dir == DOWN) //vorher in entgegen gesetzter Richtung? (Rckzug)
				{
					set_sections(INVISIBLE);
					vec_set(my.x, my.line_start_x);
					my.dir = SAFE;
					my.prev_dir = SAFE;
					return;
				}
				
				if (my.prev_dir == SAFE)//vorher im sicheren Bereich? (neue Linie --> alte Linien sind bereit abgeschlossen)
				{
					vec_set(my.line_start_x, my.prev_pos);
				}
				else						//bereits beim Ziehen einer Linie (neuer Abschnitt --> alten Abschnitt Abschlieen)
				{
					set(my.parent, SECTION_READY);
				}
				vec_set(my.section_start_x, my.prev_pos);
				vec_clamp(my.section_start_x, parent.pos_x,vector(parent.pos_x + GAME_SIZE_X, parent.pos_y + GAME_SIZE_Y, 0));
				my.parent = new(line);
				my.parent.parent = me;
				if (my.prev_section)
					my.parent.prev_section = my.prev_section;
				my.prev_section = my.parent;
			}
			break;			
				
		case DOWN:
			if(my.prev_dir != DOWN)	//neu in diese Richtung gekommen?
			{
				if (my.prev_dir == UP) //vorher in entgegen gesetzter Richtung? (Rckzug)
				{
					set_sections(INVISIBLE);
					vec_set(my.x, my.line_start_x);
					my.dir = SAFE;
					my.prev_dir = SAFE;
					return;
				}
				
				if (my.prev_dir == SAFE)//vorher im sicheren Bereich? (neue Linie --> alte Linien sind bereit abgeschlossen)
				{
					vec_set(my.line_start_x, my.prev_pos);
				}
				else						//bereits beim Ziehen einer Linie (neuer Abschnitt --> alten Abschnitt Abschlieen)
				{
					set(my.parent, SECTION_READY);
				}
				vec_set(my.section_start_x, my.prev_pos);
				vec_clamp(my.section_start_x, parent.pos_x,vector(parent.pos_x + GAME_SIZE_X, parent.pos_y + GAME_SIZE_Y, 0));
				my.parent = new(line);
				my.parent.parent = me;
				if (my.prev_section)
					my.parent.prev_section = my.prev_section;
				my.prev_section = my.parent;
			}
			break;
		
		case LEFT:
			if(my.prev_dir != LEFT)	//neu in diese Richtung gekommen?
			{
				if (my.prev_dir == RIGHT) //vorher in entgegen gesetzter Richtung? (Rckzug)
				{
					set_sections(INVISIBLE);
					vec_set(my.x, my.line_start_x);
					my.dir = SAFE;
					my.prev_dir = SAFE;
					return;
				}
				
				if (my.prev_dir == SAFE)//vorher im sicheren Bereich? (neue Linie --> alte Linien sind bereit abgeschlossen)
				{
					vec_set(my.line_start_x, my.prev_pos);
				}
				else						//bereits beim Ziehen einer Linie (neuer Abschnitt --> alten Abschnitt Abschlieen)
				{
					set(my.parent, SECTION_READY);
				}
				vec_set(my.section_start_x, my.prev_pos);
				vec_clamp(my.section_start_x, parent.pos_x,vector(parent.pos_x + GAME_SIZE_X, parent.pos_y + GAME_SIZE_Y, 0));
				my.parent = new(line);
				my.parent.parent = me;
				if (my.prev_section)
					my.parent.prev_section = my.prev_section;
				my.prev_section = my.parent;
			}
			break;
		
		case RIGHT:
			if(my.prev_dir != RIGHT)	//neu in diese Richtung gekommen?
			{
				if (my.prev_dir == LEFT) //vorher in entgegen gesetzter Richtung? (Rckzug)
				{
					set_sections(INVISIBLE);
					vec_set(my.x, my.line_start_x);
					my.dir = SAFE;
					my.prev_dir = SAFE;
					return;
				}
				
				if (my.prev_dir == SAFE)//vorher im sicheren Bereich? (neue Linie --> alte Linien sind bereit abgeschlossen)
				{
					vec_set(my.line_start_x, my.prev_pos);
				}
				else						//bereits beim Ziehen einer Linie (neuer Abschnitt --> alten Abschnitt Abschlieen)
				{
					set(my.parent, SECTION_READY);
				}
				vec_set(my.section_start_x, my.prev_pos);
				vec_clamp(my.section_start_x, parent.pos_x,vector(parent.pos_x + GAME_SIZE_X, parent.pos_y + GAME_SIZE_Y, 0));
				my.parent = new(line);
				my.parent.parent = me;
				if (my.prev_section)
					my.parent.prev_section = my.prev_section;
				my.prev_section = my.parent;
			}
			break;
			
		default:
			my.dir = SAFE;
			my.prev_dir = SAFE;
			return;
	}
}

void line() //vertikale/horizontale Linie
{
	do
	{
		wait(1);
	}while (!my.parent);
	
	vec_set(my.x, my.parent.section_start_x);
	vec_set(my.draw_size_x, my.parent.section_start_x);
	
	do
	{
		if (!is(me, SECTION_READY))
		{
			switch(my.parent.dir)
			{
				case UP:
					my.typ = V_LINE;
					vec_set(my.x, my.parent.x);
					vec_vset(my.min_x, my.x - PLAYER_SIZE, my.y, 0);
					vec_vset(my.max_x, my.draw_size_x + PLAYER_SIZE, my.draw_size_y, 0);
					break;
					
				case DOWN: 
					my.typ = V_LINE;
					vec_set(my.draw_size_x, my.parent.x);
					vec_vset(my.min_x, my.x - PLAYER_SIZE, my.y, 0);
					vec_vset(my.max_x, my.draw_size_x + PLAYER_SIZE, my.draw_size_y, 0);
					break;
					
				case LEFT:
					my.typ = H_LINE;
					vec_set(my.x, my.parent.x);
					vec_vset(my.min_x, my.x, my.y - PLAYER_SIZE, 0);
					vec_vset(my.max_x, my.draw_size_x, my.draw_size_y + PLAYER_SIZE, 0);
					break;
					
				case RIGHT:
					my.typ = H_LINE;
					vec_set(my.draw_size_x, my.parent.x);
					vec_vset(my.min_x, my.x, my.y - PLAYER_SIZE, 0);
					vec_vset(my.max_x, my.draw_size_x, my.draw_size_y + PLAYER_SIZE, 0);
					break;
			}
		}
		//muss noch ersetzt werden
		check_entities();
		draw_line(my.x, NULL, 100);
		draw_line(my.draw_size_x, vector(0,255,0), 100);
		//draw_quad(NULL, my.min_x, NULL, vector(my.max_x - my.min_x, my.max_y - my.min_y, 0), nullvector, my.parent.color, 50,0);
		wait(1);
	}while(!is(me, INVISIBLE));
	
	ent_remove(me);
}

void change_language()
{
	bool_get(INGAME);
	if (!result)
	{
		bool_toggle(GERMAN);	
		show_intro();
	}
}

void toggle_player2()
{
	bool_get(INGAME);
	if (!result)
	{
		bool_toggle(ENABLE_PLAYER2);
		show_intro();
	}
}

void pause()
{
	bool_get(INGAME);
	if (result)
	{
		bool_toggle(PAUSE);
	}
}

void ie_startup()
{
	on_l = change_language;
	on_space = toggle_player2;
	on_enter = start_game;
	on_esc = show_menu;	
	on_p = pause;
	on_pause = pause;
}